package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchRequest;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.scheduling.management.SchOperationLog;
import com.docus.server.infrastructure.dao.ISchOperationLogDao;
import com.docus.server.infrastructure.mapper.SchOperationLogMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * 采集调度器操作日志 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-07-14
 */
@Repository
public class SchOperationLogDaoImpl extends BaseDaoImpl<SchOperationLogMapper, SchOperationLog> implements ISchOperationLogDao {

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public SchOperationLog findById(String id) {
        return super.findById(id);
    }

    /**
     * 新增
     *
     * @param schOperationLog 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(SchOperationLog schOperationLog) {
        return super.save(schOperationLog);
    }

    /**
     * 编辑
     *
     * @param schOperationLog 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(SchOperationLog schOperationLog) {
        return super.updateById(schOperationLog);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(List<String> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜素
     *
     * @param searchRequest 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<SchOperationLog> search(SearchRequest searchRequest) {
        //分页
        PageHelper.startPage(searchRequest.getPageNum(), searchRequest.getPageSize());
        LambdaQueryWrapper<SchOperationLog> query = Wrappers.lambdaQuery();
        //时间范围，默认按createTime
        if (searchRequest.getBeginTime() != null) {
            query.ge(SchOperationLog::getCreateTime, searchRequest.getBeginTime());
        }
        if (searchRequest.getEndTime() != null) {
            Date endTime = searchRequest.getEndTime();
            query.le(SchOperationLog::getCreateTime, endTime);
        }
        //关键字比较，多个列or
        //if (!StringUtils.isEmpty(searchRequest.getKeyword())) {
        //单个列用like
        //query. like(SchOperationLog::getxxx, searchRequest. getKeyword());
        //多个列用like
        //query. and(sub -> sub.like(SchOperationLog::getxx1, searchRequest. getKeyword())
        // оr(). like(SchOperationLog::getXX2, searchRequest. getKeyword()))
        //);
        //}
        //默认createTime倒序排序
        query.orderByDesc(SchOperationLog::getCreateTime);
        List<SchOperationLog> list = super.find(query);
        return new PageResult<>(list);
    }

}
